## EDU.oswego.cs.dl.util.concurrent
Class SemaphoreControlledChannel

    java.lang.Object
      EDU.oswego.cs.dl.util.concurrent.SemaphoreControlledChannel

All Implemented Interfaces:
  BoundedChannel, Channel, Puttable, Takable

Direct Known Subclasses:
  BoundedPriorityQueue, Slot

    public abstract class SemaphoreControlledChannel

extends java.lang.Object
implements BoundedChannel

Abstract class for channels that use Semaphores to control puts and takes.

[ Introduction to this package. ]

Field Summary
`protected int` `capacity_`
`protected Semaphore` `putGuard_`
`protected Semaphore` `takeGuard_`

Constructor Summary
`SemaphoreControlledChannel(int capacity)` Create a channel with the given capacity and default semaphore implementation
`SemaphoreControlledChannel(int capacity, java.lang.Class semaphoreClass)` Create a channel with the given capacity and semaphore implementations instantiated from the supplied class

Method Summary
`int` `capacity()` Return the maximum number of elements that can be held.
`protected abstract java.lang.Object` `extract()` Internal mechanics of take.
`protected abstract void` `insert(java.lang.Object x)` Internal mechanics of put.
`boolean` `offer(java.lang.Object x, long msecs)` Place item in channel only if it can be accepted within msecs milliseconds.
`java.lang.Object` `poll(long msecs)` Return and remove an item from channel only if one is available within msecs milliseconds.
`void` `put(java.lang.Object x)` Place item in the channel, possibly waiting indefinitely until it can be accepted.
`int` `size()` Return the number of elements in the buffer.
`java.lang.Object` `take()` Return and remove an item from channel, possibly waiting indefinitely until such an item exists.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface EDU.oswego.cs.dl.util.concurrent.Channel
`peek`

Field Detail

### putGuard_

    protected final Semaphore putGuard_

### takeGuard_

    protected final Semaphore takeGuard_

### capacity_

    protected int capacity_

Constructor Detail

### SemaphoreControlledChannel

    public SemaphoreControlledChannel(int capacity)
                               throws java.lang.IllegalArgumentException

  Create a channel with the given capacity and default semaphore implementation

  Throws:
    `java.lang.IllegalArgumentException` - if capacity less or equal to zero

### SemaphoreControlledChannel

    public SemaphoreControlledChannel(int capacity,
                                      java.lang.Class semaphoreClass)
                               throws java.lang.IllegalArgumentException,
                                      java.lang.NoSuchMethodException,
                                      java.lang.SecurityException,
                                      java.lang.InstantiationException,
                                      java.lang.IllegalAccessException,
                                      java.lang.reflect.InvocationTargetException

  Create a channel with the given capacity and semaphore implementations instantiated from the supplied class

  Throws:
    `java.lang.IllegalArgumentException` - if capacity less or equal to zero.
    `java.lang.NoSuchMethodException` - If class does not have constructor that intializes permits
    `java.lang.SecurityException` - if constructor information not accessible
    `java.lang.InstantiationException` - if semaphore class is abstract
    `java.lang.IllegalAccessException` - if constructor cannot be called
    `java.lang.reflect.InvocationTargetException` - if semaphore constructor throws an exception

Method Detail

### capacity

    public int capacity()

  Description copied from interface: `BoundedChannel`
  Return the maximum number of elements that can be held.

  Specified by:
    `capacity` in interface `BoundedChannel`
  Returns:
    the capacity of this channel.

### size

    public int size()

  Return the number of elements in the buffer. This is only a snapshot value, that may change immediately after returning.

### insert

    protected abstract void insert(java.lang.Object x)

  Internal mechanics of put.

### extract

    protected abstract java.lang.Object extract()

  Internal mechanics of take.

### put

    public void put(java.lang.Object x)
             throws java.lang.InterruptedException

  Description copied from interface: `Channel`
  Place item in the channel, possibly waiting indefinitely until it can be accepted. Channels implementing the BoundedChannel subinterface are generally guaranteed to block on puts upon reaching capacity, but other implementations may or may not block.

  Specified by:
    `put` in interface `Channel`
  Specified by:
    `put` in interface `Puttable`
  Parameters:
    `x` - the element to be inserted. Should be non-null.
  Throws:
    `java.lang.InterruptedException` - if the current thread has been interrupted at a point at which interruption is detected, in which case the element is guaranteed not to be inserted. Otherwise, on normal return, the element is guaranteed to have been inserted.

### offer

    public boolean offer(java.lang.Object x,
                         long msecs)
                  throws java.lang.InterruptedException

  Description copied from interface: `Channel`
  Place item in channel only if it can be accepted within msecs milliseconds. The time bound is interpreted in a coarse-grained, best-effort fashion.

  Specified by:
    `offer` in interface `Channel`
  Specified by:
    `offer` in interface `Puttable`
  Parameters:
    `x` - the element to be inserted. Should be non-null.
    `msecs` - the number of milliseconds to wait. If less than or equal to zero, the method does not perform any timed waits, but might still require access to a synchronization lock, which can impose unbounded delay if there is a lot of contention for the channel.
  Returns:
    true if accepted, else false
  Throws:
    `java.lang.InterruptedException` - if the current thread has been interrupted at a point at which interruption is detected, in which case the element is guaranteed not to be inserted (i.e., is equivalent to a false return).

### take

    public java.lang.Object take()
                          throws java.lang.InterruptedException

  Description copied from interface: `Channel`
  Return and remove an item from channel, possibly waiting indefinitely until such an item exists.

  Specified by:
    `take` in interface `Channel`
  Specified by:
    `take` in interface `Takable`
  Returns:
    some item from the channel. Different implementations may guarantee various properties (such as FIFO) about that item
  Throws:
    `java.lang.InterruptedException` - if the current thread has been interrupted at a point at which interruption is detected, in which case state of the channel is unchanged.

### poll

    public java.lang.Object poll(long msecs)
                          throws java.lang.InterruptedException

  Description copied from interface: `Channel`
  Return and remove an item from channel only if one is available within msecs milliseconds. The time bound is interpreted in a coarse grained, best-effort fashion.

  Specified by:
    `poll` in interface `Channel`
  Specified by:
    `poll` in interface `Takable`
  Parameters:
    `msecs` - the number of milliseconds to wait. If less than or equal to zero, the operation does not perform any timed waits, but might still require access to a synchronization lock, which can impose unbounded delay if there is a lot of contention for the channel.
  Returns:
    some item, or null if the channel is empty.
  Throws:
    `java.lang.InterruptedException` - if the current thread has been interrupted at a point at which interruption is detected, in which case state of the channel is unchanged (i.e., equivalent to a null return).